package com.example.assignmentfive;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import org.apache.http.client.HttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.TextView;
import android.widget.Toast;

public class Movie extends Activity {
	
	private static final String FAVORITES = "My Favorite Movies";
	private static final String BOX_OFFICE = "Box Office Movies";
	private static final String IN_THEATHERS = "In Theathers Movies";
	private static final String OPENING_MOVIES = "Opening Movies";
	private static final String UPCOMING_MOVIES = "Upcoming Movies";
	
	private static final String TAG_MOVIE = "movies";
	
	private static final String TAG_ID = "id";
	private static final String TAG_TITLE = "title";
	private static final String TAG_YEAR = "year";
	private static final String TAG_MPAA_RATING = "mpaa_rating";
	
	private static final String MOVIE_OPTION = "Move Option";
	private static final String DEBUG_TAG = "MySimpleAppLogging";
	private ProgressDialog progressDialog;
	HttpClient client;
	private ArrayList<HashMap<String, String>> movieList = new ArrayList<HashMap<String, String>>();

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_movie);
        String position = null;
        
        String url = null;
        
        if (getIntent().getExtras().containsKey(MainActivity.MOVIE_OPTION)){
        	
        	
        	position = getIntent().getExtras().getString(MainActivity.MOVIE_OPTION);
        	//Log.d(DEBUG_TAG, position);
        }
        
        if(position.equals(FAVORITES)){
        	
        }
        else if(position.equals(BOX_OFFICE)){
        	url = "http://api.rottentomatoes.com/api/public/v1.0/lists/movies/box_office.json?limit=50&country=us&apikey=etmg98rh4vawpb852g9c8c5w";
        }
        else if(position.equals(IN_THEATHERS)){
        	url = "http://api.rottentomatoes.com/api/public/v1.0/lists/movies/in_theaters.json?page_limit=50&page=1&country=us&apikey=etmg98rh4vawpb852g9c8c5w";
        }
        else if(position.equals(OPENING_MOVIES)){
        	url = "http://api.rottentomatoes.com/api/public/v1.0/lists/movies/opening.json?limit=50&country=us&apikey=etmg98rh4vawpb852g9c8c5w";
        }
        else if(position.equals(UPCOMING_MOVIES)){
        	url = "http://api.rottentomatoes.com/api/public/v1.0/lists/movies/upcoming.json?page_limit=50&page=1&country=us&apikey=etmg98rh4vawpb852g9c8c5w";
        }
        
        new LoadMovies().execute(url);
        
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.activity_movie, menu);
        return true;
    }
    
    private class LoadMovies extends AsyncTask<String, Void, Void> {
    	Message newMessage = new Message();
    	Handler handlerUI = new Handler();
    	
    	@Override
    	protected void onPreExecute() {
    		progressDialog = ProgressDialog.show(Movie.this, "", "Loading Movies", true, false);
        }
    	
    	
    	@Override
		protected Void doInBackground(String... params) {
    		String url = params[0];
			try {
				newMessage = getDataHttpURLConnection(url);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} 
			return null;
			
		}
    	
    	

    	@Override
		protected void onProgressUpdate(Void... progress) {
			
		}

    	@Override
		protected void onPostExecute(Void result) {
    		
    		handlerUI.postDelayed(new Runnable() {
                @Override
                public void run() {
                	progressDialog.setMessage("Finshed Loading Movies.");
                	
                }
            }, 1000);
    		

			handlerUI.postDelayed(new Runnable() {
                @Override
                public void run() {
                	progressDialog.dismiss();
                }
            }, 2000);
			
			
			if(newMessage.getData().containsKey("ERROR")){
				Toast.makeText(getBaseContext(), newMessage.getData().getString("ERROR"), Toast.LENGTH_LONG).show();
				Log.d(DEBUG_TAG, "ERROR");
			}else{
			
				//Toast.makeText(getBaseContext(), newMessage.getData().getString("RESULT"), Toast.LENGTH_LONG).show();
				//Log.d(DEBUG_TAG, newMessage.getData().getString("RESULT"));
				
				
				 ListView movieListView = (ListView) findViewById(R.id.movieListView);
				 
			     MovieAdapter adapter = new MovieAdapter(getBaseContext(), movieList);
			     movieListView.setAdapter(adapter);
				
			}
			
			
			
			

		
	}
    

	private Message getDataHttpURLConnection(String theURLString) throws IOException, JSONException {
		Bundle bundle = new Bundle();
		Message msg = new Message();
		//Log.i(DEBUG_TAG, theURLString);
		
			try {
				JSONObject jObj = null;
				URL url  = new URL(theURLString);
				HttpURLConnection con = (HttpURLConnection) url.openConnection();
				con.setRequestMethod("GET");
				con.connect();
				int statusCode = con.getResponseCode();
				if ( statusCode == HttpURLConnection.HTTP_OK) {
					try {
						BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream()));				
						StringBuffer sb = new StringBuffer("");
						String line = "";
						while((line = in.readLine()) != null){
							sb.append(line + "\n");
						}
						in.close();
						con.disconnect();
			    		
						Log.d(DEBUG_TAG, sb.toString());
						
						jObj = new JSONObject(sb.toString());  		
						
						JSONArray movies = null;
						
						movies = jObj.getJSONArray(TAG_MOVIE);
						
			    		for(int i = 0; i< movies.length(); i++){
			    			JSONObject movieJSON = movies.getJSONObject(i); 
			    			
			    			String id = movieJSON.getString(TAG_ID);
			                String title = movieJSON.getString(TAG_TITLE);
			                String year = movieJSON.getString(TAG_YEAR);
			                String mpaa_rating = movieJSON.getString(TAG_MPAA_RATING);
			                
			                HashMap<String, String> map = new HashMap<String, String>();
			                
			                map.put(TAG_ID, id);
			                map.put(TAG_TITLE, title);
			                map.put(TAG_YEAR, year);
			                map.put(TAG_MPAA_RATING, mpaa_rating);
			                
			                movieList.add(map);
			                Log.d(DEBUG_TAG, id + " " + title + " " + " " + year + " " + mpaa_rating);
			    		}
						
						bundle.putString("RESULT", sb.toString());	
						
					
					}
					catch(IOException e){
						e.printStackTrace();
						bundle.putString("ERROR", e.toString() + " io");
					}
					catch(Exception e){
						e.printStackTrace();
						
						bundle.putString("ERROR", e.toString() + " other");
					}
					
				} else{
					bundle.putString("ERROR", "Problem with Response");
				}
			} catch (UnsupportedEncodingException e) {
				bundle.putString("ERROR", "Problem with Params");
			}
			catch (Exception e) {
				bundle.putString("ERROR", "Problem with URL");
			}
			msg.setData(bundle);
			return msg;
		}
	};
	
	public static class MovieAdapter extends ArrayAdapter<ArrayList<HashMap<String, String>>>{
		Context context;
		ArrayList<HashMap<String, String>> objects;
		
		public MovieAdapter(Context context, ArrayList<HashMap<String, String>> objects) {
			super(context, R.layout.item_row_layout);
			this.context = context;
			this.objects = objects;
		}
		
		@Override
		public View getView(int position, View convertView, ViewGroup parent) {	
			if (convertView == null) {
				LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				convertView = inflater.inflate(R.layout.item_row_layout, parent, false);
			}
			
			TextView movieTitle = (TextView) convertView.findViewById(R.id.movieTitle_text); 
			TextView movieYear = (TextView) convertView.findViewById(R.id.movieYear_text); 
			TextView mpaaRating = (TextView) convertView.findViewById(R.id.mpaaRating_text); 
			
			movieTitle.setText(objects.get(position).get(TAG_TITLE));
			movieYear.setText(objects.get(position).get(TAG_YEAR));	
			mpaaRating.setText(objects.get(position).get(TAG_MPAA_RATING));	
			
			Log.i(DEBUG_TAG, "here");
			Log.i(DEBUG_TAG, objects.get(position).get(TAG_TITLE));
			 	
			return convertView;			
		}
	
	}
}
